import { Library, Name as Person } from '@lovelidge/ln-core';
import { Car, Color } from './model/car';
import { Option } from './model/option';
import { Column, ColumnType } from './model/column';
import { Table } from './model/table';
import * as $ from 'jquery';
//
// studentRoster
//
var studentRoster = [
    new Person({
        id: 1,
        first: 'Shawn',
        last: 'Lovelidge'
    }),
    new Person({
        id: 2,
        first: 'Lisa',
        last: 'Weaver'
    }),
    new Person({
        id: 3,
        first: 'David',
        last: 'McDavid'
    }),
    new Person({
        id: 4,
        first: 'Miriam',
        last: 'Porter'
    }),
    new Person({
        id: 5,
        first: 'George',
        last: 'Jettson'
    })
];
//
// carCollection
//
var carCollection = [
    new Car({
        id: 1,
        make: 'Toyota',
        model: '4 Runner',
        color: Color.White,
        year: 2018
    }),
    new Car({
        id: 2,
        make: 'Toyota',
        model: 'Corolla',
        color: Color.Red,
        year: 2017
    }),
    new Car({
        id: 3,
        make: 'Lexus',
        model: 'ES',
        color: Color.Blue,
        year: 2016
    })
];
//
// Define Student Roster
//
var students = new Table(new Option({ sortBy: 'last', orderBy: 'id', containerId: 'idc_students' }), [
    new Column({ id: 0, field: 'id', label: 'Id', visible: true, type: ColumnType.Number, onClick: onClick }),
    new Column({ id: 1, field: 'first', label: 'First', visible: false, onClick: onClick }),
    new Column({ id: 2, field: 'last', label: 'Last', visible: true, onClick: onClick }),
    new Column({
        id: 3,
        field: 'created',
        label: 'Date Created',
        visible: true,
        type: ColumnType.DateTime,
        onClick: onClick
    })
]);
//
// Define Cars
//
var cars = new Table(new Option({ sortBy: 'year', orderBy: 'id', containerId: 'idc_car_collection' }), [
    new Column({ id: 0, field: 'id', label: 'Id', visible: true, type: ColumnType.Number, onClick: onClick }),
    new Column({ id: 1, field: 'make', label: 'Make', visible: true, onClick: onClick }),
    new Column({ id: 2, field: 'model', label: 'Model', visible: true, onClick: onClick }),
    new Column({ id: 3, field: 'color', label: 'Color', visible: true, onClick: onClick }),
    new Column({ id: 4, field: 'year', label: 'Year', visible: true, onClick: onClick })
]);
/**
 * onClick()
 * @param $event
 */
function onClick($event) {
    var column = $event.target.innerText;
    var ascending = true;
    console.info("SortBy(): " + column);
    ascending = !ascending;
    if (document.getElementById('idc_car_container').style.display === 'block') {
        cars.Sortby(column, ascending);
    }
    else {
        students.Sortby(column, ascending);
    }
}
function onSelect($event) {
    if ($event.innerText === 'Car Collection') {
        document.getElementById('idc_car_container').style.display = 'block';
        document.getElementById('idc_student_container').style.display = 'none';
    }
    else if ($event.innerText === 'Student Roster') {
        document.getElementById('idc_car_container').style.display = 'none';
        document.getElementById('idc_student_container').style.display = 'block';
    }
}
//
// Document Ready
//
$(document).ready(function () {
    //
    // Render the Student Roster
    //
    if (Library.isDefined(students)) {
        students.items = studentRoster;
    }
    //
    // Render the Car Collection
    //
    if (Library.isDefined(carCollection)) {
        cars.items = carCollection;
    }
    //
    // Handle Click Events
    //
    document.getElementsByClassName('btn')[0].addEventListener('click', function (e) {
        if (e.currentTarget.innerText.innerText === 'Car Collection') {
            document.getElementById('idc_car_container').style.display = 'block';
            document.getElementById('idc_student_container').style.display = 'none';
        }
        else if (e.currentTarget.innerText === 'Student Roster') {
            document.getElementById('idc_car_container').style.display = 'none';
            document.getElementById('idc_student_container').style.display = 'block';
        }
    }, false);
    document.getElementsByClassName('btn')[1].addEventListener('click', function (e) {
        if (e.currentTarget.innerText === 'Car Collection') {
            document.getElementById('idc_car_container').style.display = 'block';
            document.getElementById('idc_student_container').style.display = 'none';
        }
        else if (e.currentTarget.innerText === 'Student Roster') {
            document.getElementById('idc_car_container').style.display = 'none';
            document.getElementById('idc_student_container').style.display = 'block';
        }
    }, false);
});
//# sourceMappingURL=/Users/admin/Desktop/git/public/ln-typescript-2.0-template/src/index.js.map